# This file was auto-generated by Fern from our API Definition.

from ...core.pydantic_utilities import UniversalBaseModel
import pydantic
from ..interface.transport_protocol import TransportProtocol
import typing
from ..azure.subresource import Subresource
from ...core.pydantic_utilities import IS_PYDANTIC_V2


class LoadBalancingRule(UniversalBaseModel):
    """
    LoadBalancingRule represents an Azure Load Balancing Rule as defined in the Azure Go SDK:
    https://pkg.go.dev/github.com/Azure/azure-sdk-for-go/sdk/resourcemanager/network/armnetwork/v5#LoadBalancingRule
    """

    id: str
    name: str
    frontend_port: int = pydantic.Field(alias="frontendPort")
    protocol: TransportProtocol
    backend_address_pool: typing.Optional[Subresource] = pydantic.Field(alias="backendAddressPool", default=None)
    backend_address_pools: typing.Optional[typing.List[Subresource]] = pydantic.Field(
        alias="backendAddressPools", default=None
    )
    backend_port: int = pydantic.Field(alias="backendPort")
    frontend_ip_configuration: typing.Optional[Subresource] = pydantic.Field(
        alias="frontendIPConfiguration", default=None
    )

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow")  # type: ignore # Pydantic v2
    else:

        class Config:
            extra = pydantic.Extra.allow
